Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Appointment.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Appointment.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Appointment.cs	(revision 5614)
@@ -22,5 +22,4 @@
 using System;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -40,16 +39,5 @@
     public Guid ResourceId { get; set; }
 
-    protected Appointment(Appointment original, Cloner cloner)
-      : base(original, cloner) {
-      this.AllDayEvent = original.AllDayEvent;
-      this.EndDate = original.EndDate;
-      this.Recurring = original.Recurring;
-      this.RecurringId = original.RecurringId;
-      this.ResourceId = original.ResourceId;
-      this.StartDate = original.StartDate;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Appointment(this, cloner);
-    }
+
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveExperiment.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveExperiment.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveExperiment.cs	(revision 5614)
@@ -22,5 +22,4 @@
 using System;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -40,14 +39,5 @@
 
     public HiveExperiment() { }
-    protected HiveExperiment(HiveExperiment original, Cloner cloner) : base(original, cloner) {
-      this.RootJobId = original.RootJobId;
-      this.OwnerUserId = original.OwnerUserId;
-      this.DateCreated = original.DateCreated;
-      this.ResourceNames = original.ResourceNames;
-      this.LastAccessed = original.LastAccessed;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new HiveExperiment(this, cloner);
-    }
+
 
     public override string ToString() {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveExperimentPermission.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveExperimentPermission.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveExperimentPermission.cs	(revision 5614)
@@ -22,10 +22,9 @@
 using System;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
   [DataContract]
   [Serializable]
-  public class HiveExperimentPermission : HiveItemBase {
+  public class HiveExperimentPermission {
     [DataMember]
     public Guid HiveExperimentId { get; set; }
@@ -39,13 +38,5 @@
     public HiveExperimentPermission() { }
 
-    protected HiveExperimentPermission(HiveExperimentPermission original, Cloner cloner) : base(original, cloner) {
-      this.HiveExperimentId = original.HiveExperimentId;
-      this.GrantedUserId = original.GrantedUserId;
-      this.GrantedByUserId = original.GrantedByUserId;
-      this.Permission = original.Permission;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new HiveExperimentPermission(this, cloner);
-    }
+
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveItem.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveItem.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveItem.cs	(revision 5614)
@@ -1,21 +1,14 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
   [DataContract]
   [Serializable]
-  public abstract class HiveItem : HiveItemBase {
+  public abstract class HiveItem  {
     [DataMember]
     public Guid Id { get; set; }
 
     public HiveItem() { }
-    protected HiveItem(HiveItem original, Cloner cloner) : base(original, cloner) {
-      this.Id = original.Id;
-    }
+
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveItemBase.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/HiveItemBase.cs	(revision 5599)
+++ 	(revision )
@@ -1,24 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.Common;
-using System.Runtime.Serialization;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-
-namespace HeuristicLab.Services.Hive.Common.DataTransfer {
-  [DataContract]
-  [Serializable]
-  public abstract class HiveItemBase : IDeepCloneable {
-    protected HiveItemBase() { }
-    protected HiveItemBase(HiveItemBase original, Cloner cloner) {
-      cloner.RegisterClonedObject(original, this);
-    }
-
-    public abstract IDeepCloneable Clone(Cloner cloner);
-
-    public object Clone() {
-      return Clone(new Cloner());
-    }
-  }
-}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Job.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Job.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Job.cs	(revision 5614)
@@ -23,5 +23,4 @@
 using System.Collections.Generic;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -43,20 +42,9 @@
     [DataMember]
     public bool FinishWhenChildJobsFinished { get; set; }
-    
+
     public Job() {
       this.PluginsNeededIds = new List<Guid>();
     }
-    protected Job(Job original, Cloner cloner) : base(original, cloner) {
-      this.Priority = original.Priority;
-      this.CoresNeeded = original.CoresNeeded;
-      this.MemoryNeeded = original.MemoryNeeded;
-      this.PluginsNeededIds = new List<Guid>(original.PluginsNeededIds);
-      this.LastHeartbeat = original.LastHeartbeat;
-      this.IsParentJob = original.IsParentJob;
-      this.FinishWhenChildJobsFinished = original.FinishWhenChildJobsFinished;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Job(this, cloner);
-    }
+
 
     public override string ToString() {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/JobData.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/JobData.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/JobData.cs	(revision 5614)
@@ -21,12 +21,10 @@
 
 using System;
-using System.IO;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
   [DataContract]
   [Serializable]
-  public class JobData : HiveItemBase {
+  public class JobData {
     [DataMember]
     public Guid JobId { get; set; }
@@ -37,11 +35,5 @@
 
     public JobData() { }
-    protected JobData(JobData original, Cloner cloner) : base(original, cloner) {
-      if (original.Data != null) this.Data = new byte[original.Data.Length]; Array.Copy(original.Data, this.Data, original.Data.Length);
-      this.LastUpdate = original.LastUpdate;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new JobData(this, cloner);
-    }
+
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/LightweightJob.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/LightweightJob.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/LightweightJob.cs	(revision 5614)
@@ -24,5 +24,4 @@
 using System.Linq;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -54,14 +53,5 @@
       this.State = job.State;
     }
-    protected LightweightJob(LightweightJob original, Cloner cloner)
-      : base(original, cloner) {
-      this.ExecutionTime = original.ExecutionTime;
-      this.ParentJobId = original.ParentJobId;
-      this.StateLog = new List<StateLog>(original.StateLog);
-      this.State = original.State;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new LightweightJob(this, cloner);
-    }
+
 
     public void SetState(JobState state) {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/NamedHiveItem.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/NamedHiveItem.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/NamedHiveItem.cs	(revision 5614)
@@ -1,8 +1,3 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Runtime.Serialization;
-using HeuristicLab.Common;
+﻿using System.Runtime.Serialization;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -15,8 +10,5 @@
 
     protected NamedHiveItem() { }
-    protected NamedHiveItem(NamedHiveItem original, Cloner cloner) : base(original, cloner) {
-      this.Name = original.Name;
-      this.Description = original.Description;
-    }
+
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Plugin.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Plugin.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Plugin.cs	(revision 5614)
@@ -21,8 +21,5 @@
 
 using System;
-using System.Collections.Generic;
-using System.Linq;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -43,13 +40,6 @@
 
     public Plugin() { }
-    protected Plugin(Plugin original, Cloner cloner) : base(original, cloner) {
-      this.Version = original.Version;
-      this.UserId = original.UserId;
-      this.DateCreated = original.DateCreated;
-      this.IsLocal = original.IsLocal;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Plugin(this, cloner);
-    }
+
+
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/PluginData.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/PluginData.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/PluginData.cs	(revision 5614)
@@ -22,5 +22,4 @@
 using System;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -36,15 +35,6 @@
 
     public PluginData() { }
-    protected PluginData(PluginData original, Cloner cloner)
-      : base(original, cloner) {
-      if (original.Data != null)
-        this.Data = new byte[original.Data.Length];
-      Array.Copy(original.Data, this.Data, original.Data.Length);
-      this.FileName = original.FileName;
-      this.PluginId = original.PluginId;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new PluginData(this, cloner);
-    }
+
+
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Resource.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Resource.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Resource.cs	(revision 5614)
@@ -22,5 +22,4 @@
 using System;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -32,10 +31,5 @@
 
     public Resource() { }
-    protected Resource(Resource original, Cloner cloner) : base(original, cloner) {
-      this.ParentResourceId = original.ParentResourceId;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Resource(this, cloner);
-    }
+
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Slave.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Slave.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/Slave.cs	(revision 5614)
@@ -22,5 +22,4 @@
 using System;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -56,19 +55,4 @@
       SlaveState = DataTransfer.SlaveState.Idle;
     }
-    protected Slave(Slave original, Cloner cloner) : base(original, cloner) {
-      this.Cores = original.Cores;
-      this.FreeCores = original.FreeCores;
-      this.CpuSpeed = original.CpuSpeed;
-      this.Memory = original.Memory;
-      this.FreeMemory = original.FreeMemory;
-      this.SlaveState = original.SlaveState;
-      this.IsAllowedToCalculate = original.IsAllowedToCalculate;
-      this.OperatingSystem = original.OperatingSystem;
-      this.CpuArchitecture = original.CpuArchitecture;
-      this.LastHeartbeat = original.LastHeartbeat;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Slave(this, cloner);
-    }
 
     public override string ToString() {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/SlaveGroup.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/SlaveGroup.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/SlaveGroup.cs	(revision 5614)
@@ -20,9 +20,5 @@
 #endregion
 
-using System.Collections.Generic;
-using System.Linq;
 using System.Runtime.Serialization;
-using System;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -30,8 +26,4 @@
   public class SlaveGroup : Resource {
     public SlaveGroup() { }
-    protected SlaveGroup(SlaveGroup original, Cloner cloner) : base(original, cloner) { }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new SlaveGroup(this, cloner);
-    }
   }
 }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/StateLog.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/StateLog.cs	(revision 5599)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.Common/3.4/DataTransfer/StateLog.cs	(revision 5614)
@@ -22,5 +22,4 @@
 using System;
 using System.Runtime.Serialization;
-using HeuristicLab.Common;
 
 namespace HeuristicLab.Services.Hive.Common.DataTransfer {
@@ -43,15 +42,4 @@
     public StateLog() { }
 
-    protected StateLog(StateLog original, Cloner cloner) : base(original, cloner) {
-      this.DateTime = original.DateTime;
-      this.UserId = original.UserId;
-      this.SlaveId = original.SlaveId;
-      this.Exception = original.Exception;
-      this.State = original.State;
-      this.JobId = original.JobId;
-    }
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new StateLog(this, cloner);
-    }
   }
 }