Index: branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/GeneticAlgorithm.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/GeneticAlgorithm.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/GeneticAlgorithm.cs	(revision 5615)
@@ -41,5 +41,5 @@
   [Creatable("Algorithms")]
   [StorableClass]
-  public sealed class GeneticAlgorithm : EngineAlgorithm, IStorableContent {
+  public sealed class GeneticAlgorithm : HeuristicOptimizationAlgorithm, IStorableContent {
     public string Filename { get; set; }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithm.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithm.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.GeneticAlgorithm/3.3/IslandGeneticAlgorithm.cs	(revision 5615)
@@ -41,5 +41,5 @@
   [Creatable("Algorithms")]
   [StorableClass]
-  public sealed class IslandGeneticAlgorithm : EngineAlgorithm, IStorableContent {
+  public sealed class IslandGeneticAlgorithm : HeuristicOptimizationAlgorithm, IStorableContent {
     public string Filename { get; set; }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearch.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearch.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.LocalSearch/3.3/LocalSearch.cs	(revision 5615)
@@ -38,5 +38,5 @@
   [Creatable("Algorithms")]
   [StorableClass]
-  public sealed class LocalSearch : EngineAlgorithm, IStorableContent {
+  public sealed class LocalSearch : HeuristicOptimizationAlgorithm, IStorableContent {
     public string Filename { get; set; }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.NSGA2/3.3/NSGA2.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.NSGA2/3.3/NSGA2.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.NSGA2/3.3/NSGA2.cs	(revision 5615)
@@ -41,5 +41,5 @@
   [Creatable("Algorithms")]
   [StorableClass]
-  public class NSGA2 : EngineAlgorithm, IStorableContent {
+  public class NSGA2 : HeuristicOptimizationAlgorithm, IStorableContent {
     public string Filename { get; set; }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/IslandOffspringSelectionGeneticAlgorithm.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/IslandOffspringSelectionGeneticAlgorithm.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/IslandOffspringSelectionGeneticAlgorithm.cs	(revision 5615)
@@ -41,5 +41,5 @@
   [Creatable("Algorithms")]
   [StorableClass]
-  public sealed class IslandOffspringSelectionGeneticAlgorithm : EngineAlgorithm, IStorableContent {
+  public sealed class IslandOffspringSelectionGeneticAlgorithm : HeuristicOptimizationAlgorithm, IStorableContent {
     public string Filename { get; set; }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithm.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithm.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/OffspringSelectionGeneticAlgorithm.cs	(revision 5615)
@@ -41,5 +41,5 @@
   [Creatable("Algorithms")]
   [StorableClass]
-  public sealed class OffspringSelectionGeneticAlgorithm : EngineAlgorithm, IStorableContent {
+  public sealed class OffspringSelectionGeneticAlgorithm : HeuristicOptimizationAlgorithm, IStorableContent {
     public string Filename { get; set; }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/SASEGASA.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/SASEGASA.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.OffspringSelectionGeneticAlgorithm/3.3/SASEGASA.cs	(revision 5615)
@@ -41,5 +41,5 @@
   [Creatable("Algorithms")]
   [StorableClass]
-  public sealed class SASEGASA : EngineAlgorithm, IStorableContent {
+  public sealed class SASEGASA : HeuristicOptimizationAlgorithm, IStorableContent {
     public string Filename { get; set; }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/SimulatedAnnealing.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/SimulatedAnnealing.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/SimulatedAnnealing.cs	(revision 5615)
@@ -39,5 +39,5 @@
   [Creatable("Algorithms")]
   [StorableClass]
-  public sealed class SimulatedAnnealing : EngineAlgorithm, IStorableContent {
+  public sealed class SimulatedAnnealing : HeuristicOptimizationAlgorithm, IStorableContent {
     public string Filename { get; set; }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.TabuSearch/3.3/TabuSearch.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.TabuSearch/3.3/TabuSearch.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.TabuSearch/3.3/TabuSearch.cs	(revision 5615)
@@ -38,5 +38,5 @@
   [Creatable("Algorithms")]
   [StorableClass]
-  public sealed class TabuSearch : EngineAlgorithm, IStorableContent {
+  public sealed class TabuSearch : HeuristicOptimizationAlgorithm, IStorableContent {
     public string Filename { get; set; }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Optimization/3.3/Algorithm.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Optimization/3.3/Algorithm.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Optimization/3.3/Algorithm.cs	(revision 5615)
@@ -71,5 +71,5 @@
 
     public virtual Type ProblemType {
-      get { return typeof(IHeuristicOptimizationProblem); }
+      get { return typeof(IProblem); }
     }
 
Index: branches/DataAnalysis Refactoring/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Optimization/3.3/EngineAlgorithm.cs	(revision 5615)
@@ -33,5 +33,5 @@
   [Item("EngineAlgorithm", "A base class for algorithms which use an engine for execution.")]
   [StorableClass]
-  public abstract class EngineAlgorithm : HeuristicOptimizationAlgorithm {
+  public abstract class EngineAlgorithm : Algorithm {
     [Storable]
     private OperatorGraph operatorGraph;
Index: branches/DataAnalysis Refactoring/HeuristicLab.Optimization/3.3/HeuristicOptimizationAlgorithm.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Optimization/3.3/HeuristicOptimizationAlgorithm.cs	(revision 5613)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Optimization/3.3/HeuristicOptimizationAlgorithm.cs	(revision 5615)
@@ -31,5 +31,5 @@
   [Item("Heuristic Optimization Algorithm", "A base class for heuristic optimization algorithms.")]
   [StorableClass]
-  public abstract class HeuristicOptimizationAlgorithm : Algorithm {
+  public abstract class HeuristicOptimizationAlgorithm : EngineAlgorithm {
     public new IHeuristicOptimizationProblem Problem {
       get { return (IHeuristicOptimizationProblem)base.Problem; }