Index: /branches/DataAnalysis Refactoring/HeuristicLab 3.3.sln
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab 3.3.sln	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab 3.3.sln	(revision 5625)
@@ -376,4 +376,6 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.DataAnalysis.Views-3.4", "HeuristicLab.Problems.DataAnalysis.Views\3.4\HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj", "{3E9E8944-44FF-40BB-A622-3A4A7DD0F198}"
+EndProject
+Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "OutDated Plugins", "OutDated Plugins", "{CAE8D82D-2945-48A4-8091-FECC24B3D32A}"
 EndProject
 Global
@@ -1766,4 +1768,18 @@
 		{FC841674-62A7-4055-BE91-E41944B6C606} = {91243D2B-77EB-4922-BEB0-78C6AB1DEEDC}
 		{DE69A359-A5B8-4D3D-BA8D-D5780D7F96D6} = {91243D2B-77EB-4922-BEB0-78C6AB1DEEDC}
+		{70DFD984-B1D9-46FE-8EB7-4DE92D71A9FC} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{30DD3DA2-CA57-49DD-A5BA-50CEF19DB45F} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{F5C0ECAC-EDBA-4024-872A-1F74AFCB20B4} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{D35FD6DB-D704-4BEA-BDAE-C40ABFB5B13E} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{BDF86B1D-630E-4CE2-8A49-8C90B1BDE4C9} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{5A4679EF-A8F3-4647-B722-441A36B3BA6B} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{799B0B38-E384-4A17-A73C-F211EB854592} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{E86E215D-E3CE-4244-978D-555D4E17AC09} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{1778134B-866B-4CB3-BFC0-52B2FAAA5777} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{7F038E9A-B91E-4F49-8C27-D47BC86F1220} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{6F42C5F8-16CD-43EE-8208-FD4573A69D85} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{8824925E-3E00-4543-8293-7DDACE4737F8} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{125D3006-67F5-48CB-913E-73C0548F17FA} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
+		{A8D5676D-9662-437A-B44D-ECB4046CDE12} = {CAE8D82D-2945-48A4-8091-FECC24B3D32A}
 	EndGlobalSection
 EndGlobal
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.3/CrossValidation.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.3/CrossValidation.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.3/CrossValidation.cs	(revision 5625)
@@ -34,5 +34,4 @@
 namespace HeuristicLab.Algorithms.DataAnalysis {
   [Item("Cross Validation", "Cross Validation wrapper for data analysis algorithms.")]
-  [Creatable("Data Analysis")]
   [StorableClass]
   public sealed class CrossValidation : ParameterizedNamedItem, IAlgorithm, IStorableContent {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.3/LinearRegression.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.3/LinearRegression.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.3/LinearRegression.cs	(revision 5625)
@@ -39,5 +39,4 @@
   /// </summary>
   [Item("Linear Regression", "Linear regression data analysis algorithm.")]
-  [Creatable("Data Analysis")]
   [StorableClass]
   public sealed class LinearRegression : EngineAlgorithm, IStorableContent {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.3/SupportVectorMachine.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.3/SupportVectorMachine.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.3/SupportVectorMachine.cs	(revision 5625)
@@ -37,5 +37,4 @@
   /// </summary>
   [Item("Support Vector Machine", "Support vector machine data analysis algorithm.")]
-  [Creatable("Data Analysis")]
   [StorableClass]
   public sealed class SupportVectorMachine : EngineAlgorithm, IStorableContent {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/HeuristicLab.ALGLIB-3.1.0/HeuristicLab.ALGLIB-3.1.0.csproj
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/HeuristicLab.ALGLIB-3.1.0/HeuristicLab.ALGLIB-3.1.0.csproj	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/HeuristicLab.ALGLIB-3.1.0/HeuristicLab.ALGLIB-3.1.0.csproj	(revision 5625)
@@ -12,5 +12,6 @@
     <AssemblyName>HeuristicLab.ALGLIB-3.1.0</AssemblyName>
     <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
-    <TargetFrameworkProfile></TargetFrameworkProfile>
+    <TargetFrameworkProfile>
+    </TargetFrameworkProfile>
     <FileAlignment>512</FileAlignment>
     <SignAssembly>true</SignAssembly>
@@ -112,5 +113,5 @@
     <ProjectReference Include="..\..\..\..\HeuristicLab.PluginInfrastructure\3.3\HeuristicLab.PluginInfrastructure-3.3.csproj">
       <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
-      <Name>HeuristicLab.PluginInfrastructure</Name>
+      <Name>HeuristicLab.PluginInfrastructure-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\ALGLIB-3.1.0\ALGLIB-3.1.0.csproj">
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntProblem.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntProblem.cs	(revision 5625)
@@ -39,5 +39,4 @@
 namespace HeuristicLab.Problems.ArtificialAnt {
   [Item("Artificial Ant Problem", "Represents the Artificial Ant problem.")]
-  [Creatable("Problems")]
   [StorableClass]
   public sealed class ArtificialAntProblem : ParameterizedNamedItem, ISingleObjectiveHeuristicOptimizationProblem, IStorableContent {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Classification/3.3/Symbolic/SymbolicClassificationProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Classification/3.3/Symbolic/SymbolicClassificationProblem.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Classification/3.3/Symbolic/SymbolicClassificationProblem.cs	(revision 5625)
@@ -42,5 +42,4 @@
   [Item("Classification Problem", "Represents a classfication problem.")]
   [StorableClass]
-  [Creatable("Problems")]
   public sealed class SymbolicClassificationProblem : SingleObjectiveClassificationProblem<ISymbolicClassificationEvaluator, ISymbolicExpressionTreeCreator>, IStorableContent {
     private const string SymbolicExpressionTreeInterpreterParameterName = "SymbolicExpressionTreeInterpreter";
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/MultiObjectiveSymbolicRegressionProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/MultiObjectiveSymbolicRegressionProblem.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/MultiObjectiveSymbolicRegressionProblem.cs	(revision 5625)
@@ -30,5 +30,4 @@
 namespace HeuristicLab.Problems.DataAnalysis.Regression.Symbolic {
   [Item("Symbolic Regression Problem (multi objective)", "Represents a multi objective symbolic regression problem.")]
-  [Creatable("Problems")]
   [StorableClass]
   public class MultiObjectiveSymbolicRegressionProblem : SymbolicRegressionProblemBase, IMultiObjectiveHeuristicOptimizationProblem {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/SymbolicRegressionProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/SymbolicRegressionProblem.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/SymbolicRegressionProblem.cs	(revision 5625)
@@ -32,5 +32,4 @@
 namespace HeuristicLab.Problems.DataAnalysis.Regression.Symbolic {
   [Item("Symbolic Regression Problem (single objective)", "Represents a single objective symbolic regression problem.")]
-  [Creatable("Problems")]
   [StorableClass]
   public sealed class SymbolicRegressionProblem : SymbolicRegressionProblemBase, ISingleObjectiveDataAnalysisProblem {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblem.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblem.cs	(revision 5625)
@@ -31,5 +31,4 @@
 namespace HeuristicLab.Problems.DataAnalysis {
   [Item("Data Analysis Problem", "Represents a data analysis problem.")]
-  [Creatable("Problems")]
   [StorableClass]
   public class DataAnalysisProblem : ParameterizedNamedItem, IDataAnalysisProblem, IStorableContent {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/ClassificationProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/ClassificationProblem.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/ClassificationProblem.cs	(revision 5625)
@@ -27,5 +27,5 @@
   [StorableClass]
   [Item("ClassificationProblem", "")]
-  [Creatable]
+  [Creatable("Problems")]
   public class ClassificationProblem : DataAnalysisProblem<IClassificationProblemData>, IClassificationProblem {
     [StorableConstructor]
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/RegressionProblem.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/RegressionProblem.cs	(revision 5624)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis/3.4/RegressionProblem.cs	(revision 5625)
@@ -27,5 +27,5 @@
   [StorableClass]
   [Item("RegressionProblem", "")]
-  [Creatable]
+  [Creatable("Problems")]
   public class RegressionProblem : DataAnalysisProblem<IRegressionProblemData>, IRegressionProblem {
     [StorableConstructor]